#ifndef OBJECTRELATIONALACCESS_OBJECTRELATIONALMAPPINGSCHEMA_H
#define OBJECTRELATIONALACCESS_OBJECTRELATIONALMAPPINGSCHEMA_H

#include <map>
#include <vector>
#include <string>
#include <set>

namespace coral {

  class AttributeList;
  class ISchema;
  class ITableDataEditor;
}

namespace pool 
{
  
  /**
   *
   */
  
  class ObjectRelationalMappingSchema
  {
  public:
    /// Constructor
    explicit ObjectRelationalMappingSchema( coral::ISchema& schema );

    /// Destructor
    ~ObjectRelationalMappingSchema();

    bool upgradeTables();
    
    bool existTables();

    /// Creates the mapping tables
    void createTables();

    public:

    static std::set<std::string> listTables();

    private:

    coral::ISchema& m_schema;
  };
}

#endif // OBJECTRELATIONALACCESS_OBJECTRELATIONALMAPPINGSCHEMA_H
