#ifndef POOLCONTAINERMANAGERFACTORY_H
#define POOLCONTAINERMANAGERFACTORY_H

#include <string>

namespace coral {

  class ISchema;
}

namespace pool {
  
  namespace RelationalStorageService {

    class PoolBaseContainerManager;
    class MappingManager;
    class MappingSequence;
    class MappingInformation;

    class PoolContainerManagerFactory {
    public:
      static PoolBaseContainerManager* newPrimitivesContainer( int containerId,
                                                               coral::ISchema& schema,
                                                               const std::string& containerTableName );

      static PoolBaseContainerManager* newHomogeneousContainer( int containerId, const std::string& containerName,
                                                                const std::string& className, const std::string& mappingVersion,
                                                                pool::RelationalStorageService::MappingManager& mappingManager, coral::ISchema& schema);

      static PoolBaseContainerManager* newPolymorphicContainer( int containerId,
                                                                const std::string& containerName,
                                                                coral::ISchema& schema,
                                                                const std::string& containerTableName,
                                                                MappingManager& mappingManager,
                                                                MappingSequence& mappingSequences );
    };
  }
}


#endif
